#! /usr/bin/python

# this entire file is out of date and is unlikely to do anything constructive

from twisted.internet import reactor
from twisted.cred import portal, checkers
from twisted.spread import pb
from twisted.python import log
import sys

from petmail import addressbook, permission, transport, crypto, interfaces
from petmail.pbutil import NewCredPerspective

class DebugTransport:
    __implements__ = interfaces.ITransport
    def __init__(self, ref):
        self.remote = ref
    def send(self, encapsulated):
        d = self.remote.callRemote("transport", encapsulated)
        d.addErrback(log.err)

def init(ms):
    us = ms.init()
    book = ms.getAddressBook(us.ID)

    alice = addressbook.AddressBookEntry()
    alice.idRecord = i = addressbook.IDRecord()
    i.pubkey, priv = crypto.generateKeys()
    i.ID = crypto.getID(i.pubkey)
    i.name = "Alice Q. Persona"
    i.addresses = ["alice@foo.bar", "aqp@corp.foo.bar"]
    i.transport = transport.transportFromString("PB:localhost:9998")
    alice.ID = i.ID
    alice.setPetName("alice")
    alice.ourPermission = permission.PermissionSlip()
    alice.ourPermission.senderID = us.ID
    alice.ourPermission.receiverID = alice.ID
    book.addEntry(alice)

    bob = addressbook.AddressBookEntry()
    bob.idRecord = i = addressbook.IDRecord()
    i.pubkey, priv = crypto.generateKeys()
    i.ID = crypto.getID(i.pubkey)
    i.name = None
    i.addresses = ["bob@boo.far"]
    i.transport = None
    bob.ID = i.ID
    bob.setPetName("bob")
    bob.ourPermission = permission.PermissionSlip()
    bob.ourPermission.senderID = us.ID
    bob.ourPermission.receiverID = bob.ID
    book.addEntry(bob)

    return us.ID

class DebugPerspective(NewCredPerspective):
    def __init__(self, mailservice):
        self.mailservice = mailservice
        self.newMessage = None
    def perspective_test(self, arg):
        print "test!", "arg!", arg
        return "arg"

    def perspective_init(self):
        return init(self.mailservice)

    def perspective_lookupPetName(self, sender, petname):
        book = self.mailservice.getAddressBook(sender)
        entry = book.lookupPetName(petname)
        return entry.ID
        
    def perspective_sendMessage(self, senderID, recipientAddresses, body):
        s = self.mailservice
        t = None
        if self.transportRef:
            t = DebugTransport(self.transportRef)
        sender = s.getSender(senderID)
        book = s.getAddressBook(senderID)
        recipients = [book.lookupPetName(a).idRecord for a in recipientAddresses]
        self.mailservice.sendMessage(sender, recipients, body, tport=t)

    def perspective_registerNewMessageHandler(self, ref):
        self.newMessageRemote = ref
        self.mailservice.registerNewMessageHandler(self.newMessage)
    def newMessage(self, *args):
        self.newMessageRemote.callRemote("newMessage", *args)
    def perspective_unregisterNewMessageHandler(self):
        self.newMessageRemote = None
        self.mailservice.unregisterNewMessageHandler(self.newMessage)

    def perspective_injectMessage(self, encrypted):
        self.mailservice.receiveMessage(encrypted)
    def perspective_registerTransport(self, ref):
        self.transportRef = ref


class MyRealm:
    __implements__ = portal.IRealm,
    def requestAvatar(self, avatarID, mind, interface):
        assert interface == pb.IPerspective
        p = None
        if avatarID == "debug":
            p = DebugPerspective(mind)
            p.mailservice = self.mailservice
        if not p:
            raise KeyError, "no such perspective '%s'" % avatarID
        return pb.IPerspective, p, p.shutdown

def startDebugService(mailservice, slavePort=0):
    # listen for debug requests
    c = checkers.InMemoryUsernamePasswordDatabaseDontUse()
    c.addUser("debug", "pw")
    r = MyRealm()
    r.mailservice = mailservice
    p = portal.Portal(r)
    p.registerChecker(c)
    f = pb.PBServerFactory(p)
    port = reactor.listenTCP(slavePort, f)
    portnum = port.getHost()[2]
    print "debugService:", portnum
    #log.msg("BuildMaster listening on port %d" % portnum)
    sys.stdout.flush()
