#! /usr/bin/python

from distutils.core import setup

long_description = """
PETMail is a new email transport intended to eliminate spam. All
messages are signed and encrypted. Recipients give explicit permission
to senders (by keyid), and only authorized senders are allowed
unlimited access to the recipient's inbox. New senders must pass a
CAPTCHA challenge or other rate-limiting test to be allowed to send a
single message. Permission is automatically extended in ways that
correspond to natural human communication patterns.
"""

setup(name="petmail",
      version="0.0.6",
      description = "PETMail consent-based email transport",
      long_description = long_description,
      author = "Brian Warner",
      author_email = "warner-newsmtp@lothar.com",
      url = "http://www.lothar.com/tech/spam/index.html",
      license = "GNU GPL",
      packages = ["petmail", "petmail/gui", "petmail/test"],
      )

#  keep the long_description narrow enough to fit something
# Local Variables:
# fill-column: 71
# End:
